﻿Public Class Form1

    Dim k As Keys
    Dim kL As Boolean = False
    Dim kR As Boolean = False
    Dim kU As Boolean = False
    Dim kD As Boolean = False
    Dim kdL As Boolean = False
    Dim kdR As Boolean = False
    Dim kdU As Boolean = False
    Dim kdD As Boolean = False
    Dim kbL As Boolean = False
    Dim kbR As Boolean = False
    Dim kbU As Boolean = False
    Dim kbD As Boolean = False
    Dim kbdL As Boolean = False
    Dim kbdR As Boolean = False
    Dim kbdU As Boolean = False
    Dim kbdD As Boolean = False
    Dim movePlayer As Integer = 2
    Dim difficulty As Integer = 0
    Dim player2 As Boolean = False
    Dim score1 As Integer = 0
    Dim score2 As Integer = 0
    Dim rectScreen As Rectangle

    Private Sub Form1_KeyDown(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles Me.KeyDown

        'Registers each individual key being pressed, sends it into 'k' to be used in KeyPress events
        Select Case e.KeyCode
            Case Keys.W
                k = Keys.W
                tmrGame.Enabled = True
                tmrElements.Enabled = True
            Case Keys.S
                k = Keys.S
                tmrGame.Enabled = True
                tmrElements.Enabled = True
            Case Keys.A
                k = Keys.A
                tmrGame.Enabled = True
                tmrElements.Enabled = True
            Case Keys.D
                k = Keys.D
                tmrGame.Enabled = True
                tmrElements.Enabled = True
            Case Keys.I
                k = Keys.Snapshot
                picPlayer.BackColor = Color.Red
                picPlayer.Image = ImageList1.Images.Item(1)
                tmrGame.Enabled = True
                tmrElements.Enabled = True
            Case Keys.K
                k = Keys.Snapshot
                picPlayer.BackColor = Color.White
                picPlayer.Image = ImageList1.Images.Item(4)
                tmrGame.Enabled = True
                tmrElements.Enabled = True
            Case Keys.J
                k = Keys.Snapshot
                picPlayer.BackColor = Color.Green
                picPlayer.Image = ImageList1.Images.Item(2)
                tmrGame.Enabled = True
                tmrElements.Enabled = True
            Case Keys.L
                k = Keys.Snapshot
                picPlayer.BackColor = Color.Blue
                picPlayer.Image = ImageList1.Images.Item(3)
                tmrGame.Enabled = True
                tmrElements.Enabled = True
            Case Keys.NumPad8
                k = Keys.NumPad8
            Case Keys.NumPad5
                k = Keys.NumPad5
            Case Keys.NumPad4
                k = Keys.NumPad4
            Case Keys.NumPad6
                k = Keys.NumPad6
            Case Keys.Up
                If player2 = True Then
                    picBlack.BackColor = Color.Red
                    picBlack.Image = ImageList1.Images.Item(1)
                End If
            Case Keys.Down
                If player2 = True Then
                    picBlack.BackColor = Color.Black
                    picBlack.Image = ImageList1.Images.Item(0)
                End If
            Case Keys.Left
                If player2 = True Then
                    picBlack.BackColor = Color.Green
                    picBlack.Image = ImageList1.Images.Item(2)
                End If
            Case Keys.Right
                If player2 = True Then
                    picBlack.BackColor = Color.Blue
                    picBlack.Image = ImageList1.Images.Item(3)
                End If
            Case Keys.Space
                k = Keys.Snapshot
                lblText.Text = "Paused"
                If lblText.Visible = False Then
                    lblText.Visible = True
                    lblText.Top = 0
                    lblText.Left = -4
                    lblText.Width = Me.Width
                    lblText.Height = Me.Height
                    tmrGame.Enabled = False
                    tmrElements.Enabled = False

                Else
                    lblText.Visible = False
                End If
                lblHelp2.Visible = False
                lblHelp1.Visible = False
            Case Else
                k = Keys.Snapshot
        End Select

    End Sub

    Private Sub Form1_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles Me.KeyPress

        'Registers and enables events for each individual key pressed
        Select Case k
            Case Keys.W
                kU = True
                kdU = True
                kD = False
            Case Keys.S
                kD = True
                kdD = True
                kU = False
            Case Keys.A
                kL = True
                kdL = True
                kR = False
            Case Keys.D
                kR = True
                kdR = True
                kL = False
            Case Keys.NumPad8
                kbU = True
                kbdU = True
                kbD = False
            Case Keys.NumPad5
                kbD = True
                kbdD = True
                kbU = False
            Case Keys.NumPad4
                kbL = True
                kbdL = True
                kbR = False
            Case Keys.NumPad6
                kbR = True
                kbdR = True
                kbL = False
            Case Else
        End Select

    End Sub

    Private Sub Form1_KeyUp(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles Me.KeyUp

        'Registers that each key's event stops as the individual key is not pressed
        Select Case e.KeyCode
            Case Keys.W
                kU = False
                kdU = False
                If kdD = True Then
                    kD = False
                End If
            Case Keys.S
                kD = False
                kdD = False
                If kdU = True Then
                    kU = False
                End If
            Case Keys.A
                kL = False
                kdL = False
                If kdR = True Then
                    kR = True
                End If
            Case Keys.D
                kR = False
                kdR = False
                If kdL = True Then
                    kL = True
                End If

            Case Keys.NumPad8
                kbU = False
                kbdU = False
                If kbdD = True Then
                    kbD = False
                End If
            Case Keys.NumPad5
                kbD = False
                kbdD = False
                If kbdU = True Then
                    kbU = False
                End If
            Case Keys.NumPad4
                kbL = False
                kbdL = False
                If kbdR = True Then
                    kbR = True
                End If
            Case Keys.NumPad6
                kbR = False
                kbdR = False
                If kbdL = True Then
                    kbL = True
                End If
        End Select

    End Sub

    Private Sub tmrGame_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tmrGame.Tick


        If lblText.Visible = False Then

            lblHelp2.Visible = False
            lblHelp1.Visible = False

            'Calculate 1 player score
            If Player1ToolStripMenuItem.Checked = True Then
                score1 += 1
                ScoreToolStripMenuItem.Text = "Score: " & score1
                If score1 > My.Settings.HScore1 Then
                    My.Settings.HScore1 = score1
                    My.Settings.Save()
                End If
            End If

            'Calculate 2 player score
            If Player2ToolStripMenuItem.Checked = True Then
                score2 += 1
                ScoreToolStripMenuItem.Text = "Score: " & score2
                If score2 > My.Settings.HScore2 Then
                    My.Settings.HScore2 = score2
                    My.Settings.Save()
                End If
            End If

            HPlayer1ToolStripMenuItem.Text = "1 Player: " & My.Settings.HScore1
            HPlayer2ToolStripMenuItem.Text = "2 Player: " & My.Settings.HScore2

            'Adjust difficulty the longer you play
            If difficulty < 400 Then
                difficulty += 1
            Else
                If tmrElements.Interval > 11 Then
                    tmrElements.Interval -= 5
                    difficulty = 0
                Else
                    tmrElements.Interval = 1
                End If

                If player2 = False Then
                    'Change Black to another element
                    Dim Random As Integer = CInt(Int((4 * Rnd()) + 1))
                    Select Case Random
                        Case 1
                            picBlack.BackColor = Color.Black
                            picBlack.Image = ImageList1.Images.Item(0)
                        Case 2
                            picBlack.BackColor = Color.Red
                            picBlack.Image = ImageList1.Images.Item(1)
                        Case 3
                            picBlack.BackColor = Color.Green
                            picBlack.Image = ImageList1.Images.Item(2)
                        Case 4
                            picBlack.BackColor = Color.Blue
                            picBlack.Image = ImageList1.Images.Item(3)
                    End Select
                End If

            End If


            'Up Key, Move Up, Top Wall Collision
            If kU = True And picPlayer.Top > 35 Then
                picPlayer.Top = picPlayer.Top - movePlayer
                kD = False
                Select Case picPlayer.BackColor
                    Case Color.Red
                        picRed.Top = picRed.Top - movePlayer
                    Case Color.White
                        'No copying
                    Case Color.Blue
                        picBlue.Top = picBlue.Top - movePlayer
                    Case Color.Green
                        picGreen.Top = picGreen.Top - movePlayer
                End Select

            End If

            'Down Key, Move Down, Bottom Wall Collision
            If kD = True And picPlayer.Top < Me.Height - picPlayer.Height - 46 Then
                picPlayer.Top = picPlayer.Top + movePlayer
                kU = False
                Select Case picPlayer.BackColor
                    Case Color.Red
                        picRed.Top = picRed.Top + movePlayer
                    Case Color.White
                        'No copying
                    Case Color.Blue
                        picBlue.Top = picBlue.Top + movePlayer
                    Case Color.Green
                        picGreen.Top = picGreen.Top + movePlayer
                End Select
            End If

            'Left Key, Move Left, Left Wall Collision
            If kL = True And picPlayer.Left > 10 Then
                picPlayer.Left = picPlayer.Left - movePlayer
                kR = False
                Select Case picPlayer.BackColor
                    Case Color.Red
                        picRed.Left = picRed.Left - movePlayer
                    Case Color.White
                        'No copying
                    Case Color.Blue
                        picBlue.Left = picBlue.Left - movePlayer
                    Case Color.Green
                        picGreen.Left = picGreen.Left - movePlayer
                End Select
            End If

            'Right Key, Move Right, Right Wall Collision
            If kR = True And picPlayer.Left < Me.Width - picPlayer.Width - 26 Then
                picPlayer.Left = picPlayer.Left + movePlayer
                kL = False
                Select Case picPlayer.BackColor
                    Case Color.Red
                        picRed.Left = picRed.Left + movePlayer
                    Case Color.White
                        'No copying
                    Case Color.Blue
                        picBlue.Left = picBlue.Left + movePlayer
                    Case Color.Green
                        picGreen.Left = picGreen.Left + movePlayer
                End Select
            End If

            'Collision Detection with Enemies
            If picPlayer.Bounds.IntersectsWith(picBlack.Bounds) Then
                Call NewGame()
            End If
            If picPlayer.Bounds.IntersectsWith(picRed.Bounds) Then
                Call NewGame()
            End If
            If picPlayer.Bounds.IntersectsWith(picGreen.Bounds) Then
                Call NewGame()
            End If
            If picPlayer.Bounds.IntersectsWith(picBlue.Bounds) Then
                Call NewGame()
            End If

            If picBlack.Bounds.IntersectsWith(picRed.Bounds) Then
                Call NewGame()
            End If
            If picBlack.Bounds.IntersectsWith(picGreen.Bounds) Then
                Call NewGame()
            End If
            If picBlack.Bounds.IntersectsWith(picBlue.Bounds) Then
                Call NewGame()
            End If

            If picRed.Bounds.IntersectsWith(picGreen.Bounds) Then
                Call NewGame()
            End If
            If picRed.Bounds.IntersectsWith(picBlue.Bounds) Then
                Call NewGame()
            End If

            If picGreen.Bounds.IntersectsWith(picBlue.Bounds) Then
                Call NewGame()
            End If

            If Not picRed.Bounds.IntersectsWith(rectScreen) Then
                Call NewGame()
            End If
            If Not picGreen.Bounds.IntersectsWith(rectScreen) Then
                Call NewGame()
            End If
            If Not picBlue.Bounds.IntersectsWith(rectScreen) Then
                Call NewGame()
            End If

        End If

    End Sub

    Private Sub tmrElements_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tmrElements.Tick

        If lblText.Visible = False Then

            'Black chases White
            If player2 = False Then
                If picPlayer.Top > picBlack.Top Then
                    picBlack.Top += 1
                End If
                If picPlayer.Top < picBlack.Top Then
                    picBlack.Top -= 1
                End If
                If picPlayer.Left > picBlack.Left Then
                    picBlack.Left += 1
                End If
                If picPlayer.Left < picBlack.Left Then
                    picBlack.Left -= 1
                End If
            Else
                'Player 2 = Up Key, Move Up, Top Wall Collision
                If kbU = True And picBlack.Top > 35 Then
                    picBlack.Top = picBlack.Top - movePlayer / 2
                    kbD = False
                End If

                'Player 2 = Down Key, Move Down, Bottom Wall Collision
                If kbD = True And picBlack.Top < Me.Height - picBlack.Height - 46 Then
                    picBlack.Top = picBlack.Top + movePlayer / 2
                    kbU = False
                End If

                'Player 2 = Left Key, Move Left, Left Wall Collision
                If kbL = True And picBlack.Left > 10 Then
                    picBlack.Left = picBlack.Left - movePlayer / 2
                    kbR = False
                End If

                'Player 2 = Right Key, Move Right, Right Wall Collision
                If kbR = True And picBlack.Left < Me.Width - picBlack.Width - 26 Then
                    picBlack.Left = picBlack.Left + movePlayer / 2
                    kbL = False
                End If
            End If

            'Blue chases Red
            If picRed.Top > picBlue.Top Then
                picBlue.Top += 1
            End If
            If picRed.Top < picBlue.Top Then
                picBlue.Top -= 1
            End If
            If picRed.Left > picBlue.Left Then
                picBlue.Left += 1
            End If
            If picRed.Left < picBlue.Left Then
                picBlue.Left -= 1
            End If

            'Green chases Blue
            If picBlue.Top > picGreen.Top Then
                picGreen.Top += 1
            End If
            If picBlue.Top < picGreen.Top Then
                picGreen.Top -= 1
            End If
            If picBlue.Left > picGreen.Left Then
                picGreen.Left += 1
            End If
            If picBlue.Left < picGreen.Left Then
                picGreen.Left -= 1
            End If

            'Red chases Green
            If picGreen.Top > picRed.Top Then
                picRed.Top += 1
            End If
            If picGreen.Top < picRed.Top Then
                picRed.Top -= 1
            End If
            If picGreen.Left > picRed.Left Then
                picRed.Left += 1
            End If
            If picGreen.Left < picRed.Left Then
                picRed.Left -= 1
            End If

        End If

    End Sub

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Call NewGame()

        HPlayer1ToolStripMenuItem.Text = "1 Player: " & My.Settings.HScore1
        HPlayer2ToolStripMenuItem.Text = "2 Player: " & My.Settings.HScore2

    End Sub

    Private Sub NewGame()

        rectScreen = New Rectangle(-2, 25, Me.Width - 14, Me.Height - 61)

        tmrGame.Enabled = False
        tmrElements.Enabled = False

        tmrElements.Interval = 200

        score1 = 0
        score2 = 0

        picPlayer.Top = 50
        picPlayer.Left = 150

        picBlack.Top = Me.Height / 2 - picBlack.Height / 2
        picBlack.Left = 10

        picRed.Top = 35
        picRed.Left = 10

        picGreen.Top = Me.Height / 2 - picGreen.Height / 2
        picGreen.Left = Me.Width - picGreen.Width - 25

        picBlue.Top = Me.Height - picBlue.Height - 45
        picBlue.Left = 65

        picPlayer.BackColor = Color.White
        picPlayer.Image = ImageList1.Images.Item(4)
        picBlack.BackColor = Color.Black
        picBlack.Image = ImageList1.Images.Item(0)

    End Sub

    Private Sub Form1_LostFocus(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.LostFocus

        tmrGame.Enabled = False
        tmrElements.Enabled = False
        lblText.Top = 0
        lblText.Left = -4
        lblText.Width = Me.Width
        lblText.Height = Me.Height
        lblText.Visible = True
        lblHelp2.Visible = False
        lblHelp1.Visible = False

    End Sub

    Private Sub Form1_Resize(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Resize
        picPlayer.Width = Me.Height / 15
        picPlayer.Height = Me.Height / 15

        picBlack.Width = Me.Height / 15
        picBlack.Height = Me.Height / 15

        picRed.Width = Me.Height / 15
        picRed.Height = Me.Height / 15

        picGreen.Width = Me.Height / 15
        picGreen.Height = Me.Height / 15

        picBlue.Width = Me.Height / 15
        picBlue.Height = Me.Height / 15

        lblText.Top = 0
        lblText.Left = -4
        lblText.Width = Me.Width
        lblText.Height = Me.Height

        rectScreen = New Rectangle(0, 25, Me.Width, Me.Height)

        Call NewGame()
    End Sub

    Private Sub NewGameToolStripMenuItem_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles NewGameToolStripMenuItem.Click
        Call NewGame()
        lblHelp2.Visible = False
        lblHelp1.Visible = False
    End Sub

    Private Sub Player1ToolStripMenuItem_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Player1ToolStripMenuItem.Click
        If Player1ToolStripMenuItem.Checked = False Then
            Player1ToolStripMenuItem.Checked = True
            Player2ToolStripMenuItem.Checked = False
            player2 = False
            Call NewGame()
        End If
        lblHelp2.Visible = False
        lblHelp1.Visible = False
    End Sub

    Private Sub Player2ToolStripMenuItem_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles Player2ToolStripMenuItem.Click
        If Player2ToolStripMenuItem.Checked = False Then
            Player2ToolStripMenuItem.Checked = True
            Player1ToolStripMenuItem.Checked = False
            player2 = True
            Call NewGame()
        End If
        lblHelp2.Visible = False
        lblHelp1.Visible = False
    End Sub

    Private Sub MenuStrip_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles MenuStrip.Click

        lblText.Text = "Paused"
        tmrGame.Enabled = False
        tmrElements.Enabled = False
        lblText.Top = 0
        lblText.Left = 10
        lblText.Width = Me.Width - 24
        lblText.Height = Me.Height
        lblText.Visible = True
        lblHelp2.Visible = False
        lblHelp1.Visible = False
    End Sub

    Private Sub ResetToolStripMenuItem_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles ResetToolStripMenuItem.Click
        My.Settings.HScore1 = 0
        My.Settings.HScore2 = 0
        My.Settings.Save()

        HPlayer1ToolStripMenuItem.Text = "1 Player: " & My.Settings.HScore1
        HPlayer2ToolStripMenuItem.Text = "2 Player: " & My.Settings.HScore2

        lblHelp2.Visible = False
        lblHelp1.Visible = False
    End Sub

    Private Sub ViewHelpToolStripMenuItem_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles ViewHelpToolStripMenuItem.Click
        lblText.Width = Me.Width / 2
        lblHelp2.Left = Me.Width / 2
        lblHelp2.Top = 0
        lblHelp2.Width = Me.Width / 2 - 25
        lblHelp2.Height = Me.Height

        lblHelp2.Visible = True
        lblHelp1.Visible = True

        lblText.Text = "1 Player Controls" & vbCrLf & "Up: W" & vbCrLf & "Left: A" & vbCrLf & "Down: S" & vbCrLf & "Right: D" & vbCrLf & "Earth: J" & vbCrLf & "Fire: I" & vbCrLf & "Water: L" & vbCrLf & "Light: k"
        lblHelp2.Text = "2 Player Controls" & vbCrLf & "Up: Numpad8" & vbCrLf & "Left: Numpad4" & vbCrLf & "Down: Numpad5" & vbCrLf & "Right: Numpad6" & vbCrLf & "Earth: Left" & vbCrLf & "Fire : Up" & vbCrLf & "Water : Right" & vbCrLf & "Darkness : Down"
    End Sub

    Private Sub AboutToolStripMenuItem_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles AboutToolStripMenuItem.Click
        lblText.Text = "As the element of Light you must keep balance in an eternal battle for order." & vbCrLf & "You must not let the three elements of Fire, Water, and Earth collide." & vbCrLf & "Be weary of the element of Darkness. Darkness must not spread to either of the three elements of Fire, Water, and Earth; nor may Darkness collide with you. Darkness is deceitful." & vbCrLf & "As the element of Light, you have the power to mimic the three elements of Fire, Water, and Earth. As you become that element, it will in return mimic your movement; however, you must not push any element outside the realm of existance."

        lblHelp2.Visible = False
        lblHelp1.Visible = False
    End Sub
End Class
